local SpeedrunSplits_UpdateInterval = 1.0; --Time in seconds for update frequency
local SpeedrunSplitsDeltaDiff = 300; --Time for delta clock to start counting down when nearing the time for the next level
local SpeedrunSplitsFont = "Fonts\\ARIALN.ttf"

local SpeedrunSplitsLevel = nil
local SpeedrunSplitsClassID = nil
local SpeedrunSplitsRaceID = nil
local SpeedrunSplitsTotalTime = 0
local SpeedrunSplitsLevelTime = 0
local SpeedrunSplitsDeltaTime = 0
local TimeSinceLastUpdate = 0
local SpeedrunSplitsMax = nil
local SpeedrunSplitsMin = nil
local SpeedrunSplitsLevelUp = false
local SpeedrunSplitsDeltaUpdate = true

local xpos1 = 0
local ypos1 = 0
local xpos2 = 0
local ypos2 = 0
local xpos3 = 0
local ypos3 = 0

-- Run this in-game to manually set your PB times to that of the current character
-- /run p="player";_,a=UnitRace(p);_,b=UnitClass(p);SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID]=SpeedrunSplits

local NAME, S = ...
local f = CreateFrame("Frame","SpeedrunSplitsTimer",UIParent)
f:SetWidth(1) 
f:SetHeight(1) 
f:SetAlpha(1)
f:RegisterForDrag("LeftButton")

f.text = f:CreateFontString(nil,"ARTWORK") 
f.text:SetPoint("TOPLEFT",0,0)
f.text:SetJustifyH("LEFT")
f.text:SetJustifyV("TOP")
 
f.timer = f:CreateFontString(nil,"ARTWORK") 
f.timer:SetPoint("TOPLEFT",f.text,"BOTTOMLEFT",0,-5)
f.timer:SetJustifyH("LEFT")
f.timer:SetJustifyV("TOP")

f.delta = f:CreateFontString(nil,"ARTWORK") 
f.delta:SetPoint("TOPLEFT",f.text,"TOPRIGHT",5,0)
f.delta:SetJustifyH("LEFT")
f.delta:SetJustifyV("TOP")

f.times = f:CreateFontString(nil,"ARTWORK") 
f.times:SetPoint("TOPLEFT",f.delta,"TOPRIGHT",5,0)
f.times:SetJustifyH("LEFT")
f.times:SetJustifyV("TOP")

local panel = CreateFrame("Frame")
panel.name = NAME
InterfaceOptions_AddCategory(panel)

panel.title = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
panel.title:SetPoint("TOPLEFT", 16, -16)
panel.title:SetText(NAME)

panel.subtext = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
panel.subtext:SetPoint("TOPLEFT", panel.title, "BOTTOMLEFT", 0, -8)
panel.subtext:SetText("Created by Karmond")

panel.FontSlider = CreateFrame("Slider", "SpeedrunSplitsFontSlider", panel, "OptionsSliderTemplate")
panel.FontSlider:SetOrientation('HORIZONTAL')
panel.FontSlider.tooltipText = 'Size of the text displayed on screen for SpeedrunSplits'
_G["SpeedrunSplitsFontSliderLow"]:SetText("10");
_G["SpeedrunSplitsFontSliderHigh"]:SetText("20");
panel.FontSlider:SetPoint("TOPLEFT", panel.subtext, "BOTTOMLEFT", 0, -26)
panel.FontSlider:SetMinMaxValues(10,20)
panel.FontSlider:SetValueStep(1)
panel.FontSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")

panel.RangeSlider = CreateFrame("Slider", "SpeedrunSplitsRangeSlider", panel, "OptionsSliderTemplate")
panel.RangeSlider:SetOrientation('HORIZONTAL')
panel.RangeSlider.tooltipText = 'Number of levels (rows) displayed on screen for SpeedrunSplits'
_G["SpeedrunSplitsRangeSliderLow"]:SetText("5");
_G["SpeedrunSplitsRangeSliderHigh"]:SetText("30");
panel.RangeSlider:SetPoint("TOPLEFT", panel.FontSlider, "TOPRIGHT", 20, 0)
panel.RangeSlider:SetMinMaxValues(5,30)
panel.RangeSlider:SetValueStep(1)
panel.RangeSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")

panel.PBSlider = CreateFrame("Slider", "SpeedrunSplitsPBSlider", panel, "OptionsSliderTemplate")
panel.PBSlider:SetOrientation('HORIZONTAL')
panel.PBSlider.tooltipText = 'The level milestone for SpeedrunSplits to override personal best times for a race and class combo upon reaching with a faster time'
_G["SpeedrunSplitsPBSliderLow"]:SetText("5");
_G["SpeedrunSplitsPBSliderHigh"]:SetText("60");
panel.PBSlider:SetPoint("TOPLEFT", panel.RangeSlider, "TOPRIGHT", 20, 0)
panel.PBSlider:SetMinMaxValues(5,60)
panel.PBSlider:SetValueStep(1)
panel.PBSlider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")

panel.ShowHideCheckButton = CreateFrame("CheckButton", "SpeedrunSplitsShowHideCheckButton", panel, "ChatConfigCheckButtonTemplate");
panel.ShowHideCheckButton.tooltip = "Show/Hide SpeedrunSplits";
_G["SpeedrunSplitsShowHideCheckButtonText"]:SetText("Show SpeedrunSplits");
panel.ShowHideCheckButton:SetPoint("TOPLEFT", panel.FontSlider, "BOTTOMLEFT", 0, -26);

panel.MoveCheckButton = CreateFrame("CheckButton", "SpeedrunSplitsMoveCheckButton", panel, "ChatConfigCheckButtonTemplate");
panel.MoveCheckButton.tooltip = "Move SpeedrunSplits";
_G["SpeedrunSplitsMoveCheckButtonText"]:SetText("Move SpeedrunSplits");
panel.MoveCheckButton:SetPoint("TOPLEFT", panel.ShowHideCheckButton, "BOTTOMLEFT", 0, 0);

function f:OnEvent(event, arg1, arg2)
	if (event == "ADDON_LOADED" and arg1 == NAME) then
		_, SpeedrunSplitsRaceID = UnitRace("player")
		_, SpeedrunSplitsClassID = UnitClass("player")
		
		if SpeedrunSplitsPB == nil then
			SpeedrunSplitsPB = {}
		end
		if SpeedrunSplitsGold == nil then
			SpeedrunSplitsGold = {}
		end
		if SpeedrunSplitsOptions == nil then
			SpeedrunSplitsOptions = {}
			SpeedrunSplitsOptions["xpos"] = 5
			SpeedrunSplitsOptions["ypos"] = -120
			SpeedrunSplitsOptions["PBLevel"] = 40
			SpeedrunSplitsOptions["LevelRange"] = 8
			SpeedrunSplitsOptions["FontSize"] = 13
			SpeedrunSplitsOptions["Show"] = true
			SpeedrunSplitsOptions["Move"] = false
		end
		
		if not SpeedrunSplitsOptions["Show"] then
			f:Hide()
		end

		f:SetPoint("TOPLEFT",SpeedrunSplitsOptions["xpos"],SpeedrunSplitsOptions["ypos"])
		f:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" and not self.isMoving and SpeedrunSplitsOptions["Move"] then
				_, _, _, xpos1, ypos1 = f:GetPoint(1)
				self:StartMoving();
				_, _, _, xpos2, ypos2 = f:GetPoint(1)
				self.isMoving = true;
			end
		end)
		f:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and self.isMoving and SpeedrunSplitsOptions["Move"] then
				_, _, _, xpos3, ypos3 = f:GetPoint(1)
				self:StopMovingOrSizing()
				self.isMoving = false;
				SpeedrunSplitsOptions["xpos"] = xpos1 + xpos3 - xpos2
				SpeedrunSplitsOptions["ypos"] = ypos1 + ypos3 - ypos2
				self:SetPoint("TOPLEFT",SpeedrunSplitsOptions["xpos"],SpeedrunSplitsOptions["ypos"])
			end
		end)
		f:SetScript("OnHide", function(self)
			if self.isMoving then
				self:StopMovingOrSizing();
				self.isMoving = false;
			end
		end)

		f.text:SetFont(SpeedrunSplitsFont, SpeedrunSplitsOptions["FontSize"], "OUTLINE")
		f.timer:SetFont(SpeedrunSplitsFont, SpeedrunSplitsOptions["FontSize"], "OUTLINE")
		f.delta:SetFont(SpeedrunSplitsFont, SpeedrunSplitsOptions["FontSize"], "OUTLINE")
		f.times:SetFont(SpeedrunSplitsFont, SpeedrunSplitsOptions["FontSize"], "OUTLINE")

		panel.FontSlider:SetValue(SpeedrunSplitsOptions["FontSize"])
		panel.RangeSlider:SetValue(SpeedrunSplitsOptions["LevelRange"])
		panel.PBSlider:SetValue(SpeedrunSplitsOptions["PBLevel"])
		panel.ShowHideCheckButton:SetChecked(SpeedrunSplitsOptions["Show"])
		panel.MoveCheckButton:SetChecked(SpeedrunSplitsOptions["Move"])

		_G["SpeedrunSplitsFontSliderText"]:SetText("Font Size ("..SpeedrunSplitsOptions["FontSize"]..")");
		_G["SpeedrunSplitsRangeSliderText"]:SetText("Level Range ("..SpeedrunSplitsOptions["LevelRange"]..")");
		_G["SpeedrunSplitsPBSliderText"]:SetText("PB Milestone ("..SpeedrunSplitsOptions["PBLevel"]..")");

		panel.FontSlider:SetScript("OnValueChanged", function(self, newvalue)
			newvalue = floor(newvalue+0.5)
			SpeedrunSplitsOptions["FontSize"] = newvalue
			_G["SpeedrunSplitsFontSliderText"]:SetText("Font Size ("..newvalue..")");
			panel.FontSlider:SetValue(newvalue)
			f.timer:SetFont(SpeedrunSplitsFont, newvalue, "OUTLINE")
			f.text:SetFont(SpeedrunSplitsFont, newvalue, "OUTLINE")
			f.delta:SetFont(SpeedrunSplitsFont, newvalue, "OUTLINE")
			f.times:SetFont(SpeedrunSplitsFont, newvalue, "OUTLINE")
			f.times:SetWidth(f.times:GetStringWidth()+1)
		end)
		panel.RangeSlider:SetScript("OnValueChanged", function(self, newvalue)
			newvalue = floor(newvalue+0.5)
			_G["SpeedrunSplitsRangeSliderText"]:SetText("Level Range ("..newvalue..")");
			panel.RangeSlider:SetValue(newvalue)
			SpeedrunSplitsOptions["LevelRange"] = newvalue
			SpeedrunSplitsDeltaUpdate = true
			SpeedrunSplitsRange(newvalue, SpeedrunSplitsLevel)
			SpeedrunSplitsGenerate()
			SpeedrunSplitsGenerateDelta()
		end)
		panel.PBSlider:SetScript("OnValueChanged", function(self, newvalue)
			newvalue = floor(newvalue+0.5)
			_G["SpeedrunSplitsPBSliderText"]:SetText("PB Milestone ("..newvalue..")");
			panel.PBSlider:SetValue(newvalue)
			SpeedrunSplitsOptions["PBLevel"] = newvalue
		end)
		panel.ShowHideCheckButton:SetScript("OnClick",function()
			if panel.ShowHideCheckButton:GetChecked() then
				f:Show()
				SpeedrunSplitsOptions["Show"] = true
			else
				SpeedrunSplitsOptions["Show"] = false
				f:Hide()
			end
		end)
		panel.MoveCheckButton:SetScript("OnClick",function()
			if panel.MoveCheckButton:GetChecked() then
				SpeedrunSplitsOptions["Move"] = true
				SpeedrunSplitsMovable()
			else
				SpeedrunSplitsOptions["Move"] = false
				f:SetMovable(false)
				f:EnableMouse(false)
			end
		end)

		if tContains(SpeedrunSplitsPB, SpeedrunSplitsRaceID) == false then
			SpeedrunSplitsPB[SpeedrunSplitsRaceID] = {}
			SpeedrunSplitsGold[SpeedrunSplitsRaceID] = {}
		end
		if tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID], SpeedrunSplitsClassID) == false then
			SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID] = {}
			SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][1] = 0
			SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID] = {}
			SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][1] = 0
		end

		f:SetScript("OnUpdate", f.OnUpdate)
	elseif (event == "PLAYER_LOGIN") then
		SpeedrunSplitsLevel = UnitLevel("player")

		if SpeedrunSplits == nil or SpeedrunSplitsLevel == 1 then
			SpeedrunSplits = {}
			SpeedrunSplits[1] = 0
		end

		RequestTimePlayed()
		f:RegisterEvent("TIME_PLAYED_MSG")
		SpeedrunSplitsRange(SpeedrunSplitsOptions["LevelRange"], SpeedrunSplitsLevel)
	elseif (event == "PLAYER_LEVEL_UP") then
		SpeedrunSplitsLevel = arg1
		SpeedrunSplitsLevelUp = true
		RequestTimePlayed()
		f:RegisterEvent("TIME_PLAYED_MSG")
		SpeedrunSplitsRange(SpeedrunSplitsOptions["LevelRange"], arg1)
	end
	if (event == "TIME_PLAYED_MSG") then
		f:UnregisterEvent("TIME_PLAYED_MSG")
		SpeedrunSplits[SpeedrunSplitsLevel] = arg1 - arg2 
		SpeedrunSplitsTotalTime = arg1
		SpeedrunSplitsLevelTime = arg2
		local SpeedunSplitsColor = "|cffffffff"
		if SpeedrunSplitsLevel > 1 then
			if (tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], SpeedrunSplitsLevel) == false) then
				SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel] = SpeedrunSplits[SpeedrunSplitsLevel]
				if tContains(SpeedrunSplits, SpeedrunSplitsLevel-1) then
					SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel] = SpeedrunSplits[SpeedrunSplitsLevel] - SpeedrunSplits[SpeedrunSplitsLevel-1]
				end
			end
			if (tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], SpeedrunSplitsLevel-1) and tContains(SpeedrunSplits, SpeedrunSplitsLevel-1)) then
				if (SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel] - SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel-1] >= SpeedrunSplits[SpeedrunSplitsLevel] - SpeedrunSplits[SpeedrunSplitsLevel-1]) then
					SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel] = SpeedrunSplits[SpeedrunSplitsLevel] - SpeedrunSplits[SpeedrunSplitsLevel-1]
				end
			end
		end

		SpeedrunSplitsDeltaUpdate = true
		SpeedrunSplitsGenerate()
		SpeedrunSplitsGenerateDelta()

		if (SpeedrunSplitsOptions["PBLevel"] == SpeedrunSplitsLevel or SpeedrunSplitsLevel == 60) and SpeedrunSplitsLevelUp == true and SpeedrunSplits[SpeedrunSplitsLevel] <= SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel] then
			SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID] = SpeedrunSplits
			SpeedrunSplitsLevelUp = false
		end
	end
end

function f:OnUpdate(arg1)
	TimeSinceLastUpdate = TimeSinceLastUpdate + arg1;
	if (TimeSinceLastUpdate > SpeedrunSplits_UpdateInterval and SpeedrunSplitsTotalTime > 0) then
		SpeedrunSplitsTotalTime = SpeedrunSplitsTotalTime + SpeedrunSplits_UpdateInterval
		SpeedrunSplitsLevelTime = SpeedrunSplitsLevelTime + SpeedrunSplits_UpdateInterval

		SpeedrunSplitsGenerateDelta()
		
		if SpeedrunSplitsTotalTime > 0 then
			f.timer:SetText(SpeedrunSplitsTime(SpeedrunSplitsTotalTime).."\n"..SpeedrunSplitsTime(SpeedrunSplitsLevelTime))
		end

		TimeSinceLastUpdate = TimeSinceLastUpdate - SpeedrunSplits_UpdateInterval;
	end
end

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LEVEL_UP")
f:RegisterEvent("PLAYER_LOGIN")



f:SetScript("OnEvent", f.OnEvent)

function SpeedrunSplitsTime(time, diff)
	local plusminus = "+"
	if diff == 1 and time < 0 then
		time = -time
		plusminus = "-"
	end
	local h = floor(time/60/60)
	local m = floor((time-h*60*60)/60)
	local s = floor(time-h*60*60-m*60)
	if (h < 10) then
		h = "0"..tostring(h)
	else
		h = tostring(h)
	end
	if (m < 10) then
		m = "0"..tostring(m)
	else
		m = tostring(m)
	end
	if (s < 10) then
		s = "0"..tostring(s)
	else
		s = tostring(s)
	end
	if diff == nil then
		return h..":"..m..":"..s
	elseif h ~= "00" then
		return plusminus..h..":"..m..":"..s
	elseif m ~= "00" then
		return plusminus..m..":"..s
	elseif s ~= "00" then
		return plusminus..s
	else
		return ""
	end
end

function SpeedrunSplitsGenerate()
	local SpeedrunSplitsText = ""
	local SpeedrunSplitsSplitTime = ""
	for i=SpeedrunSplitsMin,SpeedrunSplitsMax do
		local SpeedrunSplitsDiffColor = "|cffffffff"
		if i > SpeedrunSplitsMin then
			SpeedrunSplitsText = SpeedrunSplitsText.."\n"
			SpeedrunSplitsSplitTime = SpeedrunSplitsSplitTime.."\n"
		end
		SpeedrunSplitsText = SpeedrunSplitsText.."Level "..i
		if i <= SpeedrunSplitsLevel and tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], i) and tContains(SpeedrunSplits, i) then
			local SpeedrunSplitsDiff = SpeedrunSplits[i]-SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][i]
			if SpeedrunSplitsDiff < 0 then
				SpeedrunSplitsDiffColor = "|cff00aa00"
			elseif SpeedrunSplitsDiff > 0 then
				SpeedrunSplitsDiffColor = "|cffff0000"
			end
			if tContains(SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], i) and tContains(SpeedrunSplits, i-1) then
				if SpeedrunSplitsGold[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][i] == SpeedrunSplits[i]-SpeedrunSplits[i-1] then
					SpeedrunSplitsDiffColor = "|cffffff00"
				end
			end
			SpeedrunSplitsSplitTime = SpeedrunSplitsSplitTime..SpeedrunSplitsDiffColor..SpeedrunSplitsTime(SpeedrunSplits[i]).."|r"
		elseif tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], i) then
			SpeedrunSplitsSplitTime = SpeedrunSplitsSplitTime..SpeedrunSplitsTime(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][i])
		end
	end

	f.text:SetText(SpeedrunSplitsText)
	f.times:SetText(SpeedrunSplitsSplitTime)
	
	f.times:SetWidth(f.times:GetStringWidth()+1)
end

function SpeedrunSplitsGenerateDelta()
	local SpeedrunSplitsDiffColor = "|cffffffff"
	local SpeedrunSplitsDeltaTime = 0
	local SpeedrunSplitsDelta = ""
	if SpeedrunSplitsLevel < 60 and tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], SpeedrunSplitsLevel+1) then
		if SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel+1] - SpeedrunSplitsDeltaDiff < SpeedrunSplitsTotalTime then
			SpeedrunSplitsDeltaUpdate = true
			SpeedrunSplitsDeltaTime = SpeedrunSplitsTotalTime - SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][SpeedrunSplitsLevel+1]
			if SpeedrunSplitsDeltaTime < 0 then
				SpeedrunSplitsDiffColor = "|cff00aa00"
			elseif SpeedrunSplitsDeltaTime > 0 then
				SpeedrunSplitsDiffColor = "|cffff0000"
			end
			SpeedrunSplitsDelta = SpeedrunSplitsDelta..SpeedrunSplitsDiffColor..SpeedrunSplitsTime(SpeedrunSplitsDeltaTime,1).."|r"
		end
	end

	if SpeedrunSplitsDeltaUpdate then
		for i=SpeedrunSplitsLevel,SpeedrunSplitsMin,-1 do
			if tContains(SpeedrunSplits, i) and tContains(SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID], i) then
				SpeedrunSplitsDeltaTime = SpeedrunSplits[i]-SpeedrunSplitsPB[SpeedrunSplitsRaceID][SpeedrunSplitsClassID][i]
				if SpeedrunSplitsDeltaTime < 0 then
					SpeedrunSplitsDiffColor = "|cff00aa00"
				elseif SpeedrunSplitsDeltaTime > 0 then
					SpeedrunSplitsDiffColor = "|cffff0000"
				end
			end
			if tContains(SpeedrunSplits, i) then
				SpeedrunSplitsDelta = SpeedrunSplitsDiffColor..SpeedrunSplitsTime(SpeedrunSplitsDeltaTime,1).."|r\n"..SpeedrunSplitsDelta
			else
				SpeedrunSplitsDelta = "\n"..SpeedrunSplitsDelta
			end
		end

		f.delta:SetText(SpeedrunSplitsDelta)
		SpeedrunSplitsDeltaUpdate = false
		if f.delta:GetWidth() < f.delta:GetStringWidth()+1 then
			f.delta:SetWidth(f.delta:GetStringWidth()+1)
		end
		if SpeedrunSplitsOptions["Move"] then
			SpeedrunSplitsMovable()
		end
	end
end

function SpeedrunSplitsMovable()
	f:SetMovable(true)
	f:EnableMouse(true)
	f:SetWidth(f.text:GetStringWidth()+f.delta:GetWidth()+f.times:GetWidth()+10) 
	f:SetHeight(f.text:GetStringHeight()+f.timer:GetStringHeight()+5)
end

function tContains(table, index)
	for key,_ in pairs(table) do
		if key == index then
			return true
		end
	end
	return false
end

function SpeedrunSplitsRange(range, level)
	SpeedrunSplitsMax = level+1
	if SpeedrunSplitsMax > 60 then
		SpeedrunSplitsMax = 60
	elseif SpeedrunSplitsMax < range+2 then
		SpeedrunSplitsMax = range+2
	end
	SpeedrunSplitsMin = SpeedrunSplitsMax-range
end


